import dash_pdf_highlighter
import dash
from dash import html, callback, Input, Output
import json
import datetime
import random

app = dash.Dash(__name__)

highlights = [
    {
        "content": {
            "text": "In the following we consider the possibility of con-trolled switching between edge currents by an additionalgate."
        },
        "position": {
            "boundingRect": {
                "x1": 528.359375,
                "y1": 398.75,
                "x2": 936.9696655273438,
                "y2": 456.03125,
                "width": 1019.9999999999999,
                "height": 1319.9999999999998,
                "pageNumber": 4,
            },
            "rects": [
                {
                    "x1": 528.359375,
                    "y1": 398.75,
                    "x2": 936.9696655273438,
                    "y2": 456.03125,
                    "width": 1019.9999999999999,
                    "height": 1319.9999999999998,
                    "pageNumber": 4,
                }
            ],
            "pageNumber": 4,
        },
        "comment": {"text": "", "emoji": ""},
        "id": "1735208822861",
    },

    {
        "content": {
            "text": "In the following we consider the possibility of con-trolled switching between edge currents by an additionalgate."
        },
        "position": {
            "boundingRect": {
                "x1": 528.359375,
                "y1": 398.75,
                "x2": 936.9696655273438,
                "y2": 456.03125,
                "width": 1019.9999999999999,
                "height": 1319.9999999999998,
                "pageNumber": 2,
            },
            "rects": [
                {
                    "x1": 528.359375,
                    "y1": 398.75,
                    "x2": 936.9696655273438,
                    "y2": 456.03125,
                    "width": 1019.9999999999999,
                    "height": 1319.9999999999998,
                    "pageNumber": 2,
                }
            ],
            "pageNumber": 2,
        },
        "comment": {"text": "", "emoji": ""},
        "id": "1231231231",
    },    
]

app.layout = html.Div(
    style={"display": "flex", "padding": "0", "margin": "0", "height": "100vh"},
    children=[
        dash_pdf_highlighter.PdfViewer(
            id="pdf-viewer",
            url="https://arxiv.org/pdf/1104.4284",
            style={"width": "70vw", "height": "100vh"},
            highlights=[]
        ),
        html.Div(
            [
                html.Button(["update highlight"], id="update-highlight"),
                html.Button(["update url"], id="update-url"),
                html.Div(id="output")
            ],
            
            style={"backgroundColor": "gray", "width": "30vw", "height": "100vh", "overflowY": "scroll"},
        )
    ],
)


@callback(Output("output", "children"), Input("pdf-viewer", "highlights"))
def update_output(highlights):
    return json.dumps(highlights)



@callback(
    Output("pdf-viewer", "highlights"),
    Input('update-highlight', "n_clicks"),
    prevent_initial_call=True
)
def update_high(_):

    for el in highlights:

        el["position"]["boundingRect"]["x1"] = random.random() * 1000.0 + 20.0
        el["position"]["rects"][0]["x1"] = el["position"]["boundingRect"]["x1"]
        el["id"] = str(int(random.random() * 100000000.0))

    if random.random() < 0.5:
        id = int(random.random()*2)
        return [highlights[id]]
        
    return highlights

@callback(
    Output("pdf-viewer", "url"),
    Input('update-url', "n_clicks"),
    prevent_initial_call=True
)
def update_url(_):
    return "https://pdfobject.com/pdf/sample.pdf"


if __name__ == "__main__":
    app.run_server(debug=True)
